
set terminal pdf monochrome enhanced dashed font 'Times,10'
 
#input
set datafile separator " "
 
#output
set key top left
set style data lines
set grid

set xlabel 'Number of Games'
set xrange [0:45000]
set xtics 10000
set mxtics 0
set format x '%6.0sK' 
 
set ylabel 'Time (milliseconds)' offset 4
set ytics nomirror
set ytics 1000
set yrange [0:1000]
set format y '%6.0sK' 

#set y2tics 250
#set autoscale y2
#set y2range [0:3000]
#set y2label '1000t Luftfracht'
 

#smooth cspline bezier

#set term pdf size 800,400 font "Arial,10"
set output "graph2.pdf"
 
plot "data.dat" using 1:2:(1.0) title "SJ optm" with linespoints axes x1y1 lc rgb 'dark-blue' lw 0.3 lt 2,\
    "data.dat" using 1:3:(1.0)  title "SJ unit" with linespoints axes x1y1 lc rgb 'blue' lw 0.3 lt 2,\
    "data.dat" using 1:4:(1.0)  title "JE Unit" with lines axes x1y1 lc rgb 'green' lw 0.3 lt 2,\
    "data.dat" using 1:5:(1.0)  title "SJ Int" with linespoints axes x1y1 lc rgb 'red' lw 0.3 lt 2,\
    "data.dat" using 1:6:(1.0)  title "JE Int" with lines axes x1y1 lc rgb 'orange' lw 0.3 lt 2,\
    "data.dat" using 1:7:(1.0)  title "SJ_S optm" with linespoints axes x1y1 lc rgb 'dark-blue' lw 0.3 lt 1,\
    "data.dat" using 1:8:(1.0)  title "SJ_S Unit" with linespoints axes x1y1 lc rgb 'blue' lw 0.3 lt 0,\
    "data.dat" using 1:9:(1.0)  title "JE_S Unit" axes x1y1 lc rgb 'green' lw 0.3 lt 0,\
    "data.dat" using 1:10:(1.0)  title "SJ_S Int" with linespoints axes x1y1 lc rgb 'red' lw 0.3 lt 0,\
    "data.dat" using 1:11:(1.0)  title "JE_S Int" axes x1y1 lc rgb 'orange' lw 0.3 lt 0
