using System;
using System.Math;
using System.Threading;

class FSM2  {
  long count=0;
  // just to keep the program similar for all numbers
  private long max1(long a1) {
    long m=a1;
    // Console.WriteLine(m);
      count-=1;
    return m;
  }

  public async evA(long l);   
  public async evB(long l);
 

  private async unblock();

  public void s() 
    & evA(long a) {
    long m=max1(a);
    if (m<count)
      evB(m+1);
    else
      unblock();
  }
  & evB(long b)  {
    long m=max1(b);
    if (m<count)
      evB(m+1);
    else
      unblock();
  }
  private DateTime block_inner() & unblock() {
    //return DateTime.Now.Ticks;
    return DateTime.Now;
  }
  public DateTime block() { // can not be part of chord
    return block_inner();
  } 
  public FSM2(long cnt) {
    count=cnt;
  }
}



public class Program {
  FSM2 fsm;
  long count;
  public Program(long _count) {
    //Console.WriteLine("Constructor");
    this.count=_count;
    fsm=new FSM2(_count);
    //Console.WriteLine("constructor done");
  }
  public static void Main() {
    Console.WriteLine("Grid Bench 2");
    for (int i=0;i<8;i++) {
      GC.Collect();
      Thread.Sleep(1000);
      Program p=new Program(1000*1000*10);
      p.start_measurement();
      Thread.Sleep(3000);
    }
  }
  private void sThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.s();
    }
  }
  private void aThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.evA(35);
    } 
  }

  private void bThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.evB(35);
    } 
 }

  public void start_measurement() {
    Thread t1=new Thread(new ThreadStart(this.aThread));
    Thread t2=new Thread(new ThreadStart(this.bThread));
    Thread ts=new Thread(new ThreadStart(this.sThread));
    DateTime before=DateTime.Now; 
    t1.Start();
    t2.Start();
    ts.Start();
    DateTime after=fsm.block(); // wait until  event sequences finish
    double ms=(after.Subtract(before)).TotalMilliseconds;
    Console.WriteLine(""+ms+"   normalize 1k "+String.Format("{0:0.00}",(1000*ms/count))+" ,  "+count+" cycles  throughput "+String.Format("{0:0.000}",(1000.0*count)/ms))  ;
  }

}
