using System;
using System.Math;
using System.Threading;

// virtual methods are less likely to be inlined


class FSM3  {
  public async up();   // 
  public async down(); //
  private async unblock();

  private async lev0(long lev) & up() {
    if (lev>0)
      lev1(lev-1);
    else
      unblock();
  }
  private async lev1(long lev) & up() {
    if (lev>0)
      lev2(lev-1);
    else
      unblock();
  }
   & down() {
    if (lev>0)
      lev0(lev-1);
    else
      unblock();
  }



  private async lev2(long lev) & down() {
    if (lev>0)
      lev1(lev-1);
    else
      unblock();
  }

  public DateTime block() { // can not be part of chord
    return block_inner();
  } 

  private DateTime block_inner() & unblock() {
    //return DateTime.Now.Ticks;
    return DateTime.Now;
  }
  async init(long level) { 
    lev0(level); // call async method in chord
  }
  public FSM3(long level) {
    init(level); // call async method (chord does not work here
  }
}

public class Program {
  FSM3 fsm;
  long count;
  public Program(long _count) {
    //Console.WriteLine("Constructor");
    this.count=_count;
    fsm=new FSM3(_count);
    //Console.WriteLine("constructor done");
  }
  public static void Main() {
    Console.WriteLine("Bench 3 Chords");
    for (int i=0;i<=8;i++) {
      GC.Collect();
      Thread.Sleep(1000);
      Program p=new Program(800*1000);
      p.start_measurement();
      Thread.Sleep(3000);
    }
  }
  private void upThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.up();
    }
  }
  private void downThread() {
    for (long iter=0;iter<=count;iter++) {
      fsm.down();
    } 
  }
  public void start_measurement() {
    Thread t1=new Thread(new ThreadStart(this.upThread));
    Thread t2=new Thread(new ThreadStart(this.downThread));
    DateTime before=DateTime.Now;
    t1.Start();
    t2.Start();
    DateTime after=fsm.block(); // wait until both event sequesnces finish
    double ms=(after.Subtract(before)).TotalMilliseconds;
    
    Console.WriteLine(""+ms+"   normalize 1k "+(1000*ms/count)+" ,  "+count+" cycles  throughput "+(1000.0*count)/ms)   ;
  }

}
