let rec max_list = function
| [] -> invalid_arg "empty list"
| [a] -> a
| t :: s -> max t (max_list s);;



let fsm count=
    def unblock() & block(strt)    = reply Unix.gettimeofday() to block
    or ea(n11)  & s(n1)    =  reply (n1+1) to s &  if count<max_list([n1;n11]) then
                                       eb(n11)
                                       else
                                       unblock()
                                  

    or eb(n21)  & s(n2)     =  reply (n2+1) to s &
                                       if count<max_list([n2;n21]) then
                                       ea(n21)
                                       else
                                       unblock()
                                       
    
				      
     in
    ([ea;eb],s,block)
;;


let asyncSend(events)= 
  let rec trigger = function
  | [] -> ()
  | t :: s -> (spawn(t(35)); trigger(s)) in
    let rec iter(iteration,limit)  = trigger(events);if iteration<=limit then iter(iteration+1,limit) else ()  in
    def async(count) = iter(0,count);0  in
    async ;;


let syncSend(spinner)= 
    let rec iter(iteration,limit)  = spinner(iteration);if iteration<=limit then iter(iteration+1,limit) else ()  in
    def sync(count) = iter(0,count);0  in
    sync ;;

let experiment(iterations)=
  let (events,spinner,block)=fsm(iterations) in
      let syncSender=syncSend(spinner) in
	  let asyncSender=asyncSend(events) in
	      let bfr=Unix.gettimeofday() in 
    spawn (syncSender(iterations) & asyncSender(iterations));
    let time=block () -. bfr in
      print_string(" total time ");
      print_float(time);
      print_string("  ");
      print_float(1000.0 *. 1000.0 *. time /. float_of_int(iterations));
      print_string(" ms for 1K ,");
      print_int(iterations);
      print_string(" cycles, throughput (/s): ");
      print_float(float_of_int(iterations) /. time);
      print_newline();;




let rec repeated(count,iterations)=experiment(iterations);Gc.compact();Unix.sleep(3);if count>0 then repeated(count-1,iterations);;




repeated(8,2*1000*1000);;

exit 0;;
