package bench

import joins._
import events._
import scala.concurrent.ops._
import scala.compat.Platform

class FSM1(val ev_count:Long) extends Joins with FSM_abs {


    private object Lev0 extends AsyncEvent[Long]
    object block extends SyncEvent[Long,Long]
    object unblock extends NullaryAsyncEvent
    object up extends NullaryAsyncEvent
    object down extends NullaryAsyncEvent
//    object up extends AsyncEvent[Long]
//    object down extends AsyncEvent[Long]
    join {
      case Lev0(x) and1 down()  => {
	if (x>0)
	  Lev0(x-1)
	else
	  unblock()
      }
      case Lev0(x) and2 up()  => {
	if (x>0)
	  Lev0(x-1)
	else
	  unblock()
      }
      case block(beg) and3 unblock() => {
	val end=Platform.currentTime
	val timed=end-beg
	block reply (timed)
      }
    }

  def block_impl=(start:Long)=>block(start)
  def up_impl=(arg:Long)=>up()
  def down_impl=(arg:Long)=>down()

  Lev0(ev_count)
}




object Benchmark1 extends Benchmarker {
  def main(args:Array[String])={
    (1 to iterations).foreach(x => {
      val x=new FSM1(count)
      cycle(x)
    })
  }
}
