package bench

import joins._
import events._
import scala.concurrent.ops._
import scala.compat.Platform

class FSM5n(val ev_count:Long) extends Joins with FSM_abs {


    private object Lev0 extends AsyncEvent[Long]  
    private object Lev1 extends AsyncEvent[Long]
    private object Lev2 extends AsyncEvent[Long]
    private object Lev3 extends AsyncEvent[Long]
    private object Lev4 extends AsyncEvent[Long]
    object block extends SyncEvent[Long,Long]
    object unblock extends NullaryAsyncEvent
    object up extends AsyncEvent[Long]
    object down extends AsyncEvent[Long]
    join {
      case Lev4(x) and1 down(_)  => {
	if (x>0)
	  Lev3(x-1)
	else
	  unblock()
      }
      case Lev3(x) and2 down(_)  => {
	if (x>0)
	  Lev2(x-1)
	else
	  unblock()
      }
      case Lev2(x) and3 down(_)  => {
	if (x>0)
	  Lev1(x-1)
	else
	  unblock()
      }
      case Lev1(x) and4 down(_)  => {
	if (x>0)
	  Lev0(x-1)
	else
	  unblock()
      }
      case Lev0(x) and5 up(_)  => {
	if (x>0)
	  Lev1(x-1)
	else
	  unblock()
      }
      case Lev1(x) and6 up(_)  => {
	if (x>0)
	  Lev2(x-1)
	else
	  unblock()
      }
      case Lev2(x) and7 up(_)  => {
	if (x>0)
	  Lev3(x-1)
	else
	  unblock()
      }
      case Lev3(x) and8 up(_)  => {
	if (x>0)
	  Lev4(x-1)
	else
	  unblock()
      }
      case block(beg) and9 unblock() => {
	val end=Platform.currentTime
	val timed=end-beg
	block reply (timed)
      }
    }

  def block_impl=(start:Long)=>block(start)
  def up_impl=(arg:Long)=>up(arg)
  def down_impl=(arg:Long)=>down(arg)

  Lev0(ev_count)
}




object Benchmark5n extends Benchmarker {
  def main(args:Array[String])={
    (1 to iterations).foreach(x => {
      val x=new FSM5n(count)
      cycle(x)
    })
  }
}
