package bench_rsp.rsp.players


import bench_rsp.rsp.arena.Arena

class Player(val name:String,val playerA:Boolean) {
  val silent=true
  var arena:Arena=null
  def setArena(a:Arena)={arena=a}
  val move_names=List("rock","sissors","paper")	
  def now=scala.compat.Platform.currentTime
  val rnd=new utils.PseudoRandom(name)
  val results=new Array[Int](3)
  var choice:Int=0
  
  def trigger()=
    if (!(arena.finished)) 
      synchronized { 
      if (playerA) {
	choice match {
          case 0 => arena.arock(results(0))
          case 1 => arena.ascissors(results(1))
          case 2 => arena.apaper(results(2))
	}
      } else {
	choice match {
          case 0 => arena.brock(results(0))
          case 1 => arena.bscissors(results(1))
          case 2 => arena.bpaper(results(2))
	}
      }
    }
  
  // value is kept in an interval
  def limit(min:Int,max:Int)(value:Int)={
    if (value<min) 
      min
    else if (value>max)
	   max
    else
      value
  }

  def play()= {
    val a=limit(2,5)(results(0))
    val b=limit(2,5)(results(1))
    val c=limit(2,5)(results(2))
    val sum=a+b+c
    val select=rnd.nextInt(sum)
    if (select<a) {
      choice=0
    } else if (select>=(a+b)) {
      choice=2
    } else { 	
      choice=1
    }
    trigger()
  }
  def status="rock:"+results(0)+"  sissors:"+results(1)+" paper:"+results(2)
  
  def handle_won(arg:Unit):Unit={
    results(choice) +=1
    if (!silent) println(name+" won "+status)
  }
  def handle_lost(arg:Unit):Unit={
    if (results(choice)>1)
      results(choice) -=1
    if (!silent) println(name+" lost "+status)
  }

}
