package eval.bench.grid6

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

class Grid6(val count:Long) extends Thread("Spinner"){
  def display(prefix:String)(arg:Any)=println(prefix+" "+arg)

  type JoinTuple=Tuple6[Long,Long,Long,Long,Long,Unit]

  val className={
    val cn=this.getClass().getName()
    val from=cn.lastIndexOf(".")
    if (from>0)
      cn.substring(from+1)
    else
      cn
  }
  var cnt:Long=0
  var halted=false
  def max(arg1:Long,arg2:Long,arg3:Long,arg4:Long,arg5:Long)={
    List(arg1,arg2,arg3,arg4,arg5).foldLeft(Long.MinValue)((z,x)=>if (z>x) z else x)
  }

  def consider(arg:JoinTuple,fun1:(Long)=>Unit,fun2:()=>Unit):Unit={
    val m=max(arg._1,arg._2,arg._3,arg._4,arg._4)
    cnt+=1
    if (cnt<count) {
    if (m>0) fun1(m-1)
    }
    else
      fun2()
  }

   val cbA=new ImperativeAsyncEvent[Long]
   val cbB=new ImperativeAsyncEvent[Long]
   val cbC=new ImperativeAsyncEvent[Long]
   val cbD=new ImperativeAsyncEvent[Long]
   val cbE=new ImperativeAsyncEvent[Long]
   val cbF=new ImperativeAsyncEvent[Long]
 
 // cbA += display("cbA") _
 // cbB += display("cbB") _
 // cbC += display("cbC") _
 // cbD += display("cbD") _

  val done=new ImperativeAsyncEvent[Unit]
  val s =new ImperativeEvent[Unit]

  val (resF,resE,resD,resC,resB,resA)= mkDisjunction(
    mkChord(cbA,cbB,cbC,cbD,cbE,s),
    mkChord(cbF,cbA,cbB,cbC,cbD,s),
    mkChord(cbE,cbF,cbA,cbB,cbC,s),
    mkChord(cbD,cbE,cbF,cbA,cbB,s),
    mkChord(cbC,cbD,cbE,cbF,cbA,s),
    mkChord(cbB,cbC,cbD,cbE,cbF,s)
    )

  resA += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbA(a)),(()=>ready())))
  resB += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbB(a)),(()=>ready())))
  resC += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbC(a)),(()=>ready())))
  resD += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbD(a)),(()=>ready())))
  resE += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbE(a)),(()=>ready())))
  resF += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbF(a)),(()=>ready())))
 
 val blockBegin=new ImperativeEvent[Long]
 val ready=new ImperativeAsyncEvent[Unit]
  def block(s:Long)={
   start
   blockBegin(s)
 }
 
  val res=mkDisjunction(mkChord(blockBegin,ready))

  res += finished _
  protected def finished(a:(Long,Unit)):Unit={
    val ended=Platform.currentTime
    halted=true
    val begin=a._1
    val timed=ended-begin
    println(className+" "+count+" in "+timed+"ms  normalized ms/1K %3.3f".format(1000.0*timed/count)+"  throughput(/s): %9.2f".format(1000.0*count/timed))
    done()
  }

  override def run()=while (!halted) {
    s()
  }


}
  
class Emitter(val g:Grid6,val fun:(Long)=>Unit,name:String) extends Thread(name) {
  var halted:Boolean=false
  def halt(arg:Unit):Unit={halted=true  }
  override def run()={
    var cycle=0
    while (!halted) {
      fun(35)
      cycle+=1
      if (cycle%30==0)
	Thread.sleep(1)
    }
  }
  def remove()={
    g.done-=halt _
  }
  g.done+=halt _
}

class Cycle(val count:Long) {
  val g=new Grid6(count)
  var begin:Long=0
  var ended:Long=0
  val l=List(
    new Emitter(g,((arg:Long)=>g.cbA(arg)),"cbA"),
    new Emitter(g,((arg:Long)=>g.cbB(arg)),"cbB"),
    new Emitter(g,((arg:Long)=>g.cbC(arg)),"cbC"),
    new Emitter(g,((arg:Long)=>g.cbD(arg)),"cbD"),
    new Emitter(g,((arg:Long)=>g.cbE(arg)),"cbE"),
    new Emitter(g,((arg:Long)=>g.cbF(arg)),"cbF")
    )
 
  def start={
    System.gc
    val s=Platform.currentTime
    l.foreach(e => e.start())
    g.block(s)
    l.foreach(e => e.remove())
    l.foreach(e => e.halt())
  }
}

object R_EventGrid6 {
  def main(arg:Array[String])={
    var iters:Long=300000
    if (arg.length>0)
      iters=arg(0).toLong
    else
      println("specify number of iterations as argument")
    (1 to 8).foreach (i=>{
      Thread.sleep(100)
      System.gc()
      Thread.sleep(500)
      val c=new Cycle(iters)
      c.start
    })
  }
}
