package eval.bench

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

class FSM2s(count:Long) extends FSMs_abs(count) {
  private val lev0=new ImperativeAsyncEvent[Long]
  private val lev1=new ImperativeAsyncEvent[Long]


  val (to_lev1_1,to_lev0_1,ready)=mkDisjunction(
    mkChord(lev0,up),
    mkChord(lev1,down),
    mkChord(block,unblock)
  )

  val to_lev0_stripped=to_lev0_1 map firstLong
  val to_lev1_stripped=to_lev1_1 map firstLong

  val to_lev0_delay= to_lev0_stripped 
  val to_lev1_delay= to_lev1_stripped 

  val to_unblock_delay=(to_lev0_stripped || to_lev1_stripped)  && completed

  to_lev0_delay += ((a:Long)=>lev0(a+1))
  to_lev1_delay += ((a:Long)=>lev1(a+1))

  to_unblock_delay += ((a:Long)=>unblock())
  ready += finished _
  ready += ((arg:(Long,Unit))=>to_lev0_1.disable())
  lev0(0)
}


object R_Benchmark2s extends Benchmarkers {
  val count=500000
  def main(args:Array[String])={
    (1 to iterations).foreach(x => {
      val x=new FSM2s(count)
      cycle(x)
    })
  }
}
