package eval.boundedbuffer

import scala.events.{ImperativeEvent,ImperativeAsyncEvent,Observable}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
// global loc 67  ev: 7 handler: 2 imp: 3

// ev: 4  handler: 1 imp: 0
class Cell {
  val set=new ImperativeEvent[Int]
  set += ((arg:Int)=>setVal(arg))
  var myVal:Int=0
  lazy val setVal=Observable(_setVal)
  def _setVal(arg:Int):Unit={
    myVal=arg
  }
  lazy val read=Observable(_read)
  def _read(arg:Unit)={myVal}
  val coord=mkDisjunction(mkChord(read.before,setVal.afterAsync))
  //coord.markSync(setVal.after)
}

// ev: 3 handler: 1  imp: 2
class Bounded {
   val put=new ImperativeAsyncEvent[Int]
   val get_i=new ImperativeEvent[Cell]
   val mtch=mkDisjunction(mkChord(get_i,put))
   mtch +=readAndSend _
   def readAndSend(arg:(Cell,Int)):Unit={
     val cell=arg._1
     val vl=arg._2
     cell.set(vl)
   }
   def get()={
     val c=new Cell
     get_i(c)
     c.read()
   }
}

// imp:1
class Putter(val name:String,b:Bounded) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  def halt()={halting=true}
  override def run=while (!halting) {
    b.put(rnd.nextInt(10))
    Thread.sleep(1000+20*rnd.nextInt(50))
  }
}

class Getter(val name:String,b:Bounded) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  def halt()={halting=true}
  override def run=while (!halting) {
    println("get "+name+" "+b.get())
    Thread.sleep(100+20*rnd.nextInt(30))
  }
}

object R_BoundBuffer {
	val b=new Bounded
	val putter=new Putter("putter",b)
	val getters=List(new Getter("first_getter",b),new Getter("second_getter",b))
	def start={
	  putter.start()
	  getters.foreach(g=>g.start)
	}
	def halt={
	  putter.halt()
	  getters.foreach(g=>g.halt)
	}
	def main(arg:Array[String])={
	  start
	  Thread.sleep(10*1000)
	  halt
	}
	
}
