package eval.critical_section;


import scala.events._
import scala.events.sugarjoin.{mkChord,mkDisjunction}

// # cloc 60
// # events 5
// # handlers 0

class AServer {
  val rnd=new scala.util.Random
  def sleep_a_bit={
                Thread.sleep(100+15*rnd.nextInt(50))
  }
  def internal_handle(task:List[Int])={
                val threadName=Thread.currentThread().getName()
                task.foreach(a => {
                        println("printing "+a+" for thread "+threadName)
                })
  }
}


class AClient(name:String) extends Thread(name) {
        val rnd=new scala.util.Random
        val requestList=(1 to 10).toList
        var halting=false
        def halt={halting=true}
        def isHalting=halting

        def sleep_a_bit={
                Thread.sleep(100+15*rnd.nextInt(50))
        }

        override def start={
                halting=false
                super.start
        }

}

class Server extends AServer {
	
	val handle=Observable(internal_handle _)
}

class Client(name:String,s:Server)  extends AClient(name) {
	
	override def run() {
		println("begin client "+name)
		while (!isHalting) {
			sleep_a_bit
			s.handle(requestList)
		}
	}

}
 
class Coordinator(s:Server) {
	def display(n:String)(a:Any)=println(n+" "+a)
	lazy val started=s.handle.before.dropParam
	lazy val ended=s.handle.before.dropParam
	
	
	lazy val free=new ImperativeEvent[Unit]
	lazy val unlock=ended || free
	lazy val dummy=mkDisjunction(mkChord(started,unlock))
//	dummy.markSync(started)
	
	free()
}

object R_CriticalSection {
	val server=new Server
	val clients=List("c1","c2","c3").map((nm:String)=>new Client(nm,server))
	
	val c=new Coordinator(server)
	def main(args:Array[String])={
		clients.foreach(c=>c.start)
		Thread.sleep(10*1000)
		clients.foreach(c=>c.halt)
	}
}
