package eval.pthread.condition_variable

import scala.events.{ImperativeEvent,ImperativeAsyncEvent,Observable}
import scala.events.sugarjoin.{mkDisjunction,mkChord}

// cloc 56

class CondVar_JE {
  var waiting=0
  val waitUp=Observable(_waitUp)
  def _waitUp(dummy:Unit)=synchronized   {waiting+=1;waiting}
  def waitDown()=synchronized {waiting-=1;waiting}
  val waitTryDown=Observable(_waitTryDown)
  def _waitTryDown(dummy:Unit):Boolean=synchronized {
    if (waiting>0) {
      waiting-=1
      true
    } else {
      false
    }
  }
  val reqwait=new ImperativeEvent[Unit]
  val signal=new ImperativeEvent[Unit]
  val broadcast=new ImperativeAsyncEvent[Unit]
  val _broadcast=broadcast || iterate
  reqwait += ((arg:Unit)=>waitUp())
  
  val block=waitUp.after.dropParam
  
  val (un1,un2)=mkDisjunction(
          mkChord(block,signal    ),
		  mkChord(block, _broadcast )  )
  //un1.markSync(block)
  un1 += ((arg:Any)=>waitDown())
  un2 += ((arg:Any)=>waitTryDown())
  
  lazy val iterate=((waitTryDown.afterAsync) && ((arg:(Unit,Boolean)) => arg._2) ).dropParam 
  
}

class Iter(cv:CondVar_JE,text:String) extends Thread {
	var halting=false
	def halt={halting=true}
	override def run=while (!halting) {
	  Thread.sleep(400)
	  println("wait")
	  cv.reqwait()
	  println(text)
	}
}


object Runner {
  val cv=new CondVar_JE
  def main(arg:Array[String])={
    val iterations=List(
        new Iter(cv,"Iteration 1")    ,
        new Iter(cv,"Other Iteration") )
    var counter=0
    iterations.foreach(i => i.start())
    while (counter<10) {
      Thread.sleep(2000)
      cv.broadcast()
      println("signal")
      counter+=1
    }
  }
}
