package evaldsl.barrier

import scala.events.{Observable,ImperativeEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}

//#cloc 37
//#events : 3
//#imper 0
//#handler : 0
//#triggers: 0

class Shared {
  val myBegin=scala.compat.Platform.currentTime
  var t1:Trigger=null
  var t2:Trigger=null
  def setT1(t:Trigger)={t1=t}
  def setT2(t:Trigger)={t2=t}

  val doMethod=Observable(_doMethod)
  def _doMethod(arg:Unit)={
    println("called by "+Thread.currentThread+" at "+(scala.compat.Platform.currentTime-myBegin)/10)
  }
  val b1=doMethod.before && ((arg:Unit) => Thread.currentThread==t1)
  val b2=doMethod.before && ((arg:Unit) => Thread.currentThread==t2)
  val barrier=mkDisjunction(mkChord(b1,b2))
  //barrier.markSync(b1)
  //barrier.markSync(b2)
}


class Trigger(val name:String,shared:Shared) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  def halt={halting=true}
  override def run=while (!halting) {
    shared.doMethod()
    Thread.sleep(1000+20*rnd.nextInt(50))
  }
}


object R_Barrier {
  val s=new Shared
  val t1=new Trigger("alpha",s)
  val t2=new Trigger("beta",s)
  def main(arg:Array[String])={
    s.setT1(t1)
    s.setT2(t2)
    t1.start()
    t2.start()
  }
}
