package evaldsl.bench

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.events.dsl.TriggerDSL
import scala.compat.Platform

class FSM1s(count:Long) extends FSMs_abs(count) with TriggerDSL {
  private val lev0=new ImperativeAsyncEvent[Long]

  val (to_lev0_1,to_lev0_2,ready)=mkDisjunction(
    mkChord(lev0,up),
    mkChord(lev0,down),
    mkChord(block,unblock)
  )
 // ready.set_optimized_async(false)
  val to_lev0_stripped=(to_lev0_1 || to_lev0_2) map firstLong
  val to_unblock_delay=(to_lev0_stripped)  && completed

  to_lev0_stripped += ((a:Long)=>lev0(a+1))
 

  to_unblock_delay triggers unblock
  ready += ((arg:Any)=>to_lev0_1.disable())
  ready += finished _

  lev0(0)
}


object R_Benchmark1s extends Benchmarkers {
  val count=100000
  //scala.events.disjunctjoin.InEvent.set_debug(true)
  //scala.events.disjunctjoin.Chord.set_debug(true)
//  scala.events.disjunctjoin.Disjunction.set_debug(true)
  def main(args:Array[String])={
    (1 to iterations).foreach(x => {
      val x=new FSM1s(count)
      cycle(x)
    })
  }
}
