package evaldsl.counter

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkChord,mkDisjunction}
import scala.events.dsl.ProjectionDSL

//#cloc 44   
//#events 6 
//#imper 3 
//#handler 1 
//#trigger 3


// ev: 3+2+1  handler: 1  imp:2
class Counter(initial:Int=10) extends ProjectionDSL {
  val inc= new ImperativeEvent[Unit]
  val dec= new ImperativeEvent[Unit]
  val state=new ImperativeAsyncEvent[Int]
  state += ((arg:Int)=>println("Counter value :"+arg))
  val (moveUp,moveDown)=mkDisjunction(
      mkChord(state,inc)  ,
      mkChord(state,dec)  )
//  moveUp.markSync(inc)
//  moveUp.markSync(dec)
   println()
  lazy val move=(moveUp._1 map((_:Int)+1)) || (moveDown._1 map ((_:Int)-1))
  move += ((arg:Int)=>{
	  Thread.sleep(100)  // a very slow setter 
	  state(arg)
	  Thread.sleep(100)
  })
  state(initial)
}

// imp : 2
class Trigger(val c:Counter) extends Thread {
  val rnd=new scala.util.Random()
  var halting:Boolean=false
  def halt={halting=true}
  override def run=while (!halting) {
    Thread.sleep(150+15*rnd.nextInt(20))
    if (rnd.nextBoolean)
      c.inc()
    else	
      c.dec()
  }
}

object R_Counter {
  val counter=new Counter
  val indexes=(1 to 5).toList
  val triggers=indexes.map(i=>new Trigger(counter))
  def start=triggers.foreach(t => t.start)
  def halt=triggers.foreach(t=>t.halt)
  def main(args:Array[String])={
    start
    Thread.sleep(10*1000)
    halt
  }
}

