package evaldsl.finiteStateMachine.multithread


import scala.events._
import scala.events.sugarjoin.{mkChord,mkDisjunction}
import scala.events.dsl.FSM_J

//# cloc 56
//# ev: 2 
//# imper 2
//# handlers 2
//# trigger 2


sealed trait Level
object Bottom extends Level
object Middle extends Level
object Top extends Level

class Elevator extends FSM_J[Level] {                    
  lazy val up=new ImperativeAsyncEvent[Unit] 
  lazy val down=new ImperativeAsyncEvent[Unit] 
  
  Bottom -> Middle on up apply(()=>reachMiddle())
  Middle -> Top on up apply(()=>reachTop())
  Top -> Middle on down apply(()=>reachMiddle())
  Middle -> Bottom on down apply(()=>reachBottom())

  initialState(Bottom)

  up+=moveUp _
  down+=moveDown _
  def moveUp(arg:Any):Unit={
	  println(" moving up    <")
  }
  def moveDown(arg:Any):Unit={
	  println(" moving down  >")
  }

  def reachTop():Unit={
    println("Top      [+    ]")
  }

  def reachMiddle():Unit={
    println("Middle   [  +  ]")
  }

  def reachBottom():Unit={
    println("Bottom   [    +]")
  }

}


// imp 2
class ButtonPusher(val el:Elevator) extends Thread {
  val rnd=new scala.util.Random
  var halting=false
  def halt={halting=false}
  override def run=while (!halting) {
    if (rnd.nextBoolean) 
      el.up()
    else
      el.down()
    Thread.sleep(600+30*rnd.nextInt(20))
  }
}

object R_FSM_mt {
  val indexes=(1 to 4).toList
  val elevator=new Elevator
  val buttonPushers=indexes.map(i=>new ButtonPusher(elevator))
  def main(arg:Array[String])={
    buttonPushers.foreach(b => b.start)
    Thread.sleep(60*1000)
    buttonPushers.foreach(b => b.halt)
  }
}

