package evaldsl.finiteStateMachine.singlethread


import scala.events._
import scala.events.sugarjoin.{mkChord,mkDisjunction}
import scala.events.dsl.FSM_J

//# cloc 58
//# events: 2
//# imper: 2
//# handler : 2 
//# trigger 2

trait Level {}
object Bottom extends Level {}
object Middle extends Level {}
object Top extends Level {}

class Elevator extends FSM_J[Level]{
  lazy val rnd=new scala.util.Random
                    
  lazy val up=new ImperativeAsyncEvent[Unit] 
  lazy val down=new ImperativeAsyncEvent[Unit] 
  
  Bottom -> Middle on up apply(()=>reachMiddle())
  Middle -> Top on up apply(()=>reachTop())
  Top -> Middle on down apply(()=>reachMiddle())
  Middle -> Bottom on down apply(()=>reachBottom())
  initialState(Bottom)

  up+=moveUp _
  down+=moveDown _
  def moveUp(arg:Any):Unit={
	  println(" moving up    <")
  }
  def moveDown(arg:Any):Unit={
	  println(" moving down  >")
  }

  def reachTop(arg:Any):Unit={
    println("Top      [+    ]")
  }

  def reachMiddle(arg:Any):Unit={
    println("Middle   [  +  ]")
  }

  def reachBottom(arg:Any):Unit={
    println("Bottom   [    +]")
  }

 
}


// imp 2
class ButtonPusher(val el: Elevator) {
  val rnd = new scala.util.Random
  var halting = false
  def now = scala.compat.Platform.currentTime
  val begin = now
  def run(sec: Int) = {
    val end = now + sec * 1000
    while (now < end) {
      if (rnd.nextBoolean)
        el.up()
      else
        el.down()
      Thread.sleep(600 + 30 * rnd.nextInt(20))
    }
  }
}

object R_FSM_st {
  val elevator=new Elevator
  val buttonPusher=new ButtonPusher(elevator)
  def main(arg:Array[String])={
    buttonPusher.run(40)
  }
}
