package evaldsl.networks.util
import scala.collection.mutable.ListBuffer

//class Node(val id:Int ,val cnt:Container) {
 
//}

class AdjacencyMatrix(val size:Int)  {
	private val rnd=new scala.util.Random	
    private val indexes=(0 to size).toList
    private val connections=indexes.map(x => {
      val l=new ListBuffer[Boolean]
      indexes.filter(i=>(i<=x)).foreach(e => l+=false)		
      l
    })
    def read(from:Int,to:Int)=if (from<to)
    	read_inner(to,from)
      else 
        read_inner(from,to)
    private def read_inner(from:Int,to:Int)={
        if (from<0 || to <0) false
        else {
          if (from>size || to>size) 
            false
        else 
          connections(from)(to)    
        }
      }    
        
        
    def mark(from:Int,to:Int)=if (from<to)
    	connections(to)(from)=true
      else 
        connections(from)(to)=true
    def listConnections(node:Int)=indexes.filter(other=>read(node,other))
    
    private def leastConnected=indexes.map(x=> (x,listConnections(x).length)).sortWith((a,b)=>(a._2<b._2))
    
    def addRandom(min:Int,max:Int)={
       val con=leastConnected
       if (con.head._2 <= min) {
         addRandom_inner(con.head._1,max)
       } else {
         val p=rnd.nextInt(con.length)
         addRandom_inner(con(p)._1,max)
       }
     }
    
    private def addRandom_inner(from:Int, max:Int)={
      val connections=listConnections(from)
      if (connections.length >= max) {
          false
      } else {
    	  var target=(0-1)
    	  var limitLoop=10
    	  while ((target==(0-1) || connections.contains(target)) && limitLoop>0) {
    		limitLoop-=1
    	    target=rnd.nextInt(size)
    	  }
    	  if (limitLoop>0 && listConnections(target).length<max) {
    		  mark(from,target)
    		  true
    	  } else {
    	    false
    	  } 
      }
    }
    def createConnection(under:Int, upper:Int)= {
      while (addRandom(under,upper)) {}
      this
    }
    def dump={
      indexes.map(r => indexes.map(c=>(if (read(r,c)) "* " else "  ")).foldLeft("")((z,x)=>z+x)+"\n" )
    }
}

object Test {
  def main(arg:Array[String])={
    val v=new AdjacencyMatrix(10)
    v.createConnection(2, 5)
 
    while (v.addRandom(2,4)) {}
    
  }
}
