package evaldsl.prodcons

import scala.events._
import scala.events.sugarjoin.{mkChord,mkDisjunction}

//# cloc  72
//# events 8
//# imper 1
//# handlers 0
//# trigger 1

class  Requestor(name:String,action:()=>Unit) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  override def start={
    halting=false
    super.start
  }
  override def run={
    while (!halting) {
      action()
      Thread.sleep(100+10*rnd.nextInt(50))
    }
  }
  def halt={halting=true}
}



class Gateway {
  var value:Int=0
  val getValue=Observable(_getValue)
  val setValue=Observable(_setValue)
  def _setValue(v:Int):Unit=synchronized{value=v}
  def _getValue(dummy:Unit)={
    val v=value
    value=0
    v
    }
}


class Producer(name:String,g:Gateway) {
  val r=new Requestor(name,mth _)
  val rnd=r.rnd
  def mth():Unit={
    g.setValue(rnd.nextInt(100))
  }
  def start=r.start
  def halt=r.halt
}


class Consumer(val name:String,g:Gateway) {
   val r=new Requestor(name,mth _)
  def mth():Unit={
    val v=g.getValue()
    println("read by "+name+" "+v)
  }
  def start=r.start
  def halt=r.halt
}

class Coordinator(val g:Gateway) {
  lazy val initialize=new ImperativeAsyncEvent[Unit]
  lazy val canRead=g.setValue.afterAsync.dropParam
  lazy val canWrite=g.getValue.afterAsync.dropParam
  lazy val startWrite=g.setValue.before.dropParam
  lazy val startRead=g.getValue.before.dropParam
  val (v1,v2,v3)=mkDisjunction(
      mkChord(startWrite,canWrite   ),
      mkChord(startRead,canRead     ),
      mkChord(startWrite,initialize))
//   v1.markSync(startWrite)
//   v1.markSync(startRead)
   initialize()
}


object R_ProdCons {
  val g=new Gateway
  val p=new Producer("producer",g)
  val c=new Consumer("consumer",g)
  def main(arg:Array[String])={
    val coord=new Coordinator(g)
	  p.start
	  c.start
	  Thread.sleep(10*1000)
	  p.halt
	  c.halt
  }
}
