package evaldsl.reader_writer

import scala.events.{Observable,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.events.dsl.TriggerDSL
//# cloc 72
//# events: 8   
//# imper: 2
//# handlers: 1  
//# triggers:3
class Memory extends TriggerDSL{
	val readerAllowed=new ImperativeAsyncEvent[Int]
	val writerAllowed=new ImperativeAsyncEvent[Unit]
	var memory:Int=0
	val read=Observable(_read)
	def _read(arg:Unit):Int={
		println("beginRead")
		Thread.sleep(1000)
		println("endRead")
		memory
	}

	val write=Observable(_write)
	def _write(m:Int):Unit={
	println("beginWrite "+m)
	Thread.sleep(1000)
	memory=m
	println("endWrite   "+m)
	}

	val beginRead=read.before.dropParam
	val beginWrite=write.before.dropParam
	val endRead=read.afterAsync.dropParam
	val endWrite=write.afterAsync.dropParam

	val (moreReaders,firstReader,lessReaders,writer)=mkDisjunction(
	    mkChord(beginRead,readerAllowed),
	    mkChord(beginRead,writerAllowed) ,
	    mkChord(endRead,readerAllowed)  ,
	    mkChord(beginWrite,writerAllowed)
	    )
	 //moreReaders.markSync(beginRead)
	 //moreReaders.markSync(beginWrite)

	 def strip(arg:(Unit,Int))=arg._2

	 val allowWrite=(((lessReaders map strip _) && ((x:Int)=>(x==1)) ) .dropParam) || endWrite
	 val allowRead=((moreReaders map strip _) map ((x:Int)=>(x+1))) || (((lessReaders map strip _) && ((x:Int)=>(x>1))) map ((x:Int)=>x-1)) || (firstReader map ((x:Any)=>1))

	 allowWrite triggers writerAllowed
	 allowRead triggers readerAllowed
	 readerAllowed += ((arg:Int)=>println("readers busy "+arg))
	 writerAllowed()
}


class Reader(val m:Memory,name:String) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  def halt={halting=true}
  override def run=while(!halting) {
    Thread.sleep(600+25*rnd.nextInt(20))
    println("read :"+m.read())
  }
}


class Writer(val m:Memory,name:String) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  def halt={halting=true}
  override def run=while(!halting) {
    Thread.sleep(600+25*rnd.nextInt(20))
    m.write(rnd.nextInt(100))
  }
}

object R_Reader_Writer {
  val mem=new Memory
  val rnames=List("alpha","beta","gamma")
  val wnames=List("Zeus","Thor","Jupiter")
  val readers=rnames.map(r=>new Reader(mem,r))
  val writers=wnames.map(r=>new Writer(mem,r))

  def main(arg:Array[String])={
    readers.foreach(r=>r.start)
    writers.foreach(w=>w.start)
    Thread.sleep(40*1000)
    readers.foreach(r=>r.halt)
    writers.foreach(w=>w.halt)


  }

}
