package evaldsl.rendezvous

import scala.events.{ImperativeEvent,Observable}
import scala.events.sugarjoin.{mkDisjunction,mkChord}

//#cloc 64
//#events: 3
//#imper 0  
//#handler: 1 
//#trigger:0

class Cell(x:Int,y:Int) {
  var a:Int=x
  var b:Int=y
  def getTuple=(a,b)
  def setTuple(arg:(Int,Int))={
    a=arg._1
    b=arg._2
  }
  override def toString="Cell("+a+","+b+")"
}

class DualClass {
  def sort(arg1:(Int,Int),arg2:(Int,Int))={
    val l=List(arg1._1,arg1._2,arg2._1,arg2._2).sortWith((a,b)=>a<b)
    ((l(0),l(1)),(l(2),l(3)))
  }
  
  val method1=Observable(_method1)
  def _method1(arg:Cell)={
    println("method1 "+arg)
  }
  val method2=Observable(_method2)
  def _method2(arg:Cell)={
    println("method2 "+arg)
  }
  
  val rendezvous=mkDisjunction(mkChord(method1.before,method2.before))
  //rendezvous.markSync(method1.before)
  //rendezvous.markSync(method2.before)
  
  rendezvous += ((arg:(Cell,Cell))=>{
    val t1=arg._1.getTuple
    val t2=arg._2.getTuple
    val (r1,r2)=sort(t1,t2)
    println("rendez vous"+t1+" "+t2)
    arg._1.setTuple(r1)
    arg._2.setTuple(r2)
  })
  
}


class Trigger(name:String,f:(()=>Unit)) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  def halt={halting=true}
  override def run=while(!halting) {
    Thread.sleep(500+25*rnd.nextInt(20))
    f()
  }
}

object R_Rendezvous {
  val rnd=new scala.util.Random
  val d=new DualClass
  def randomCell=new Cell(rnd.nextInt(10),5+rnd.nextInt(10))
  def m1()={
    val c=randomCell
    d.method1(c)
  }
  def m2()={
    val c=randomCell
    d.method2(c)
  }
  
  val triggers=List(new Trigger("Poseidon",m1 _),new Trigger("Neptunus",m2 _)  )
  def main(arg:Array[String])={
    triggers.foreach(t=>t.start)
    Thread.sleep(10*1000)
    triggers.foreach(t=>t.halt)
  }
}

