package evalnodsl.agent.pingpong.singlethread

import scala.events.{ImperativeEvent,ImperativeAsyncEvent,Observable,EventNode}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

//# thread 1
//# cloc 64
//# events 7
//# imper 1
//# handlers 4 
//# trigger 4

class Agent(val name:String) {
  val rnd=new scala.util.Random
  val tick=new ImperativeAsyncEvent[Unit]
  var n1:Agent=null
  var n2:Agent=null
  var receive:EventNode[Int]=null
  var handle:EventNode[(Int,Unit)]=null
  def set_neigh(arg1:Agent,arg2:Agent)={
    receive=arg1.sendToN2.beforeAsync || arg2.sendToN1.beforeAsync
    val handle=mkDisjunction(mkChord(receive,tick))
    handle += send _ 
  }
  def send(arg:(Int,Unit)):Unit={
    val core=1+arg._1
    println(name+" received "+core)
    if (rnd.nextBoolean)
      sendToN1(core)
    else
      sendToN2(core)
  }
  val sendToN1=Observable(_sendToN1)
  def _sendToN1(arg:Int):Unit={
  }
  val sendToN2=Observable(_sendToN2)
  def _sendToN2(arg:Int):Unit={
  }
}
class PingPong(val a1:Agent,val a2:Agent,val a3:Agent) {
  val progress=new ImperativeEvent[Unit]
  val (to1,to2,to3)=mkDisjunction(
    mkChord(a1.receive,progress),
    mkChord(a2.receive,progress),
    mkChord(a3.receive,progress))    
//  to1.markSync(progress)
    to1+=((arg:Any)=>a1.tick())
    to2+=((arg:Any)=>a2.tick())
    to3+=((arg:Any)=>a3.tick())
}


class pingpong_je {
  val c1=new Agent("sun")
  val c2=new Agent("moon")
  val c3=new Agent("earth")
  c1.set_neigh(c2,c3)
  c2.set_neigh(c3,c1)
  c3.set_neigh(c2,c1)
 
  val pingpong=new PingPong(c1,c2,c3)
  def progress()=pingpong.progress()
  c1.sendToN1(4)
}


object R_PingPong {
  val p=new pingpong_je
  def main(arg:Array[String])={
    println("pingpong cycle")
    val time:Long=Platform.currentTime
    while (Platform.currentTime-time<10*1000) {
      p.progress()
      Thread.sleep(600)
    }
  }
}
