package evalnodsl.agent.tokenring.multithread

import scala.events.{ImperativeEvent,Observable,EventNode}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

//#cloc 54
//#events 3=  1imp + 2(receive+handle)
//#imper 1
//#handler 1
//#trigger 1

class Agent(val name:String) extends Thread {
  
  val tick=new ImperativeEvent[Unit]
  var receive:EventNode[Int]=null
  var handle:EventNode[(Int,Unit)]=null
  def set_neigh(arg1:Agent,arg2:Agent)={
    receive=arg1.sendToN2.beforeAsync
    val handle=mkDisjunction(mkChord(receive,tick))
    handle += send _ 
  }
  def send(arg:(Int,Unit)):Unit={
     val core=1+arg._1
     println(name+" received "+core)
     sendToN2(core)
  }

  val sendToN2=Observable(_sendToN2)
  def _sendToN2(arg:Int):Unit={
  }
   var halting=false
  def halt={halting=true}
  override def run()={
    while (!halting) {
    	tick()
       Thread.sleep(600)
    }
  }
}


class TokenRing_je {
  val c1=new Agent("sun")
  val c2=new Agent("moon")
  val c3=new Agent("earth")
   c1.set_neigh(c2,c3)
   c2.set_neigh(c3,c1)
   c3.set_neigh(c1,c2)
   val agents=List(c1,c2,c3)
    
   def start=agents.foreach(x=>x.start)
   def halt=agents.foreach(x=>x.halt)
   
   c2.sendToN2(4)
}


object R_Tokenring {
  val t=new TokenRing_je
  def main(arg:Array[String])={
    println("pingpong cycle")
    t.start
    val time:Long=Platform.currentTime
    while (Platform.currentTime-time<10*1000) {
      Thread.sleep(600)
    }
    t.halt
  }
}
