package evalnodsl.agent.tokenring.singlethread

import scala.events.{ImperativeEvent,Observable,EventNode}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

//# cloc 54
//#event 6 =  1+2+1+3
//#imper 2
//#handler 4
//# trigger 4

class Agent(val name:String) {
  
  val tick=new ImperativeEvent[Unit]
  var receive:EventNode[Int]=null
  var handle:EventNode[(Int,Unit)]=null
  def set_neigh(arg1:Agent,arg2:Agent)={
    receive=arg1.sendToN2.beforeAsync 
    val handle=mkDisjunction(mkChord(receive,tick))
    handle += send _ 
  }
  def send(arg:(Int,Unit)):Unit={
     val core=1+arg._1
     println(name+" received "+core)
     sendToN2(core)
  }

  val sendToN2=Observable(_sendToN2)
  def _sendToN2(arg:Int):Unit={
  }
}
class TokenRing(val a1:Agent,val a2:Agent,val a3:Agent) {
  val progress=new ImperativeEvent[Unit]
  val (to1,to2,to3)=mkDisjunction(
    mkChord(a1.receive,progress),
    mkChord(a2.receive,progress),
    mkChord(a3.receive,progress))    
  //to1.markSync(progress)
    to1+=((arg:Any)=>a1.tick())
    to2+=((arg:Any)=>a2.tick())
    to3+=((arg:Any)=>a3.tick())
}


class TokenRing_je {
  val c1=new Agent("sun")
  val c2=new Agent("moon")
  val c3=new Agent("earth")
  c1.set_neigh(c2,c3)
  c2.set_neigh(c3,c1)
  c3.set_neigh(c1,c2)
 
  val tokenr=new TokenRing(c1,c2,c3)
  def progress()=tokenr.progress()
  c2.sendToN2(4)
}


object R_Tokenring {
  val t=new TokenRing_je
  def main(arg:Array[String])={
    println("pingpong cycle")
    val time:Long=Platform.currentTime
    while (Platform.currentTime-time<10*1000) {
      t.progress()
      Thread.sleep(600)
    }
  }
}
