package evalnodsl.bench.grid2

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

class Grid2(val count:Long) extends Thread("Spinner"){
  def display(prefix:String)(arg:Any)=println(prefix+" "+arg)
  type JoinTuple=Tuple2[Long,Unit]
  val className={
    val cn=this.getClass().getName()
    val from=cn.lastIndexOf(".")
    if (from>0)
      cn.substring(from+1)
    else
      cn
  }
  var cnt:Long=0
  var halted=false

  def max(arg1:Long)={
    List(arg1).foldLeft(Long.MinValue)((z,x)=>if (z>x) z else x)
  }
  def consider(arg:JoinTuple,fun1:(Long)=>Unit,fun2:()=>Unit):Unit={
    val m=max(arg._1)
    cnt+=1
    if (cnt<count) {
    if (m>0) fun1(m-1)
    }
    else
      fun2()
  }

   val cbA=new ImperativeAsyncEvent[Long]
   val cbB=new ImperativeAsyncEvent[Long]
 
  
 // cbA += display("cbA") _
 // cbB += display("cbB") _
 // cbC += display("cbC") _
 // cbD += display("cbD") _

  val done=new ImperativeAsyncEvent[Unit]
  val s =new ImperativeEvent[Unit]

  val (resB,resA)= mkDisjunction(
    mkChord(cbA,s),
    mkChord(cbB,s))

  resA += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbA(a)),(()=>ready())))
  resB += ((arg:JoinTuple)=>consider(arg,((a:Long)=>cbB(a)),(()=>ready())))
 
 val blockBegin=new ImperativeEvent[Long]
 val ready=new ImperativeAsyncEvent[Unit]
  def block={
   start
   blockBegin(Platform.currentTime)
 }
 
  val res=mkDisjunction(mkChord(blockBegin,ready))

  res += finished _
  protected def finished(a:(Long,Unit)):Unit={
    val ended=Platform.currentTime
    halted=true
    val begin=a._1
    val timed=ended-begin
    println(className+" "+count+" in "+timed+"ms  normalized ms/1K %3.3f".format(1000.0*timed/count)+"  throughput(/s): %9.2f".format(1000.0*count/timed))
    done()
  }

  override def run()=while (!halted) {
    s()
  }


}
  
class Emitter(val g:Grid2,val fun:(Long)=>Unit,name:String) extends Thread(name) {
  var halted:Boolean=false
  def halt(arg:Unit):Unit={halted=true  }
  override def run()={
    var cycle=0
    while (!halted) {
      fun(35)
      cycle+=1
      if (cycle%30==0)
	Thread.sleep(1)
    }
  }
  def remove()={
    g.done-=halt _
  }
  g.done+=halt _
}

class Cycle(val count:Long) {
  val g=new Grid2(count)
  var begin:Long=0
  var ended:Long=0
  val l=List(
    new Emitter(g,((arg:Long)=>g.cbA(arg)),"cbA"),
    new Emitter(g,((arg:Long)=>g.cbB(arg)),"cbB")
    )
 
  def start={
    System.gc
    l.foreach(e => e.start())
    g.block
    l.foreach(e => e.remove())
    l.foreach(e => e.halt())
  }
}

object R_EventGrid2 {
  def main(arg:Array[String])={
    var iters:Long=300000
    if (arg.length>0)
      iters=arg(0).toLong
    else
      println("specify number of iterations as argument")
    (1 to 8).foreach (i=>{
      Thread.sleep(500)
      System.gc()
      Thread.sleep(500)
      val c=new Cycle(iters)
      c.start
    })
  }
}
