package evalnodsl.bench

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

class FSM4(count:Long) extends FSM_abs (count) {
  private val lev0=new ImperativeAsyncEvent[Long]
  private val lev1=new ImperativeAsyncEvent[Long]
  private val lev2=new ImperativeAsyncEvent[Long]
  private val lev3=new ImperativeAsyncEvent[Long]


  val (to_lev1_1,to_lev2_1,to_lev3_1,
       to_lev0_1,to_lev1_2,to_lev2_2, 
       ready)=mkDisjunction(
    mkChord(lev0,up),
    mkChord(lev1,up),
    mkChord(lev2,up),
    mkChord(lev1,down),
    mkChord(lev2,down),
    mkChord(lev3,down),
    mkChord(block,unblock)
  )
  val to_lev0_stripped=to_lev0_1 map ((a:(Long,Long))=>a._1)
  val to_lev1_stripped=(to_lev1_1 || to_lev1_2) map ((a:(Long,Long))=>a._1)
  val to_lev2_stripped=(to_lev2_1 || to_lev2_2) map ((a:(Long,Long))=>a._1)
  val to_lev3_stripped=to_lev3_1 map ((a:(Long,Long))=>a._1)

  val to_lev0_delay= to_lev0_stripped  && ((a:Long)=>(a>0))
  val to_lev1_delay= to_lev1_stripped  && ((a:Long)=>(a>0))
  val to_lev2_delay= to_lev2_stripped  && ((a:Long)=>(a>0))
  val to_lev3_delay= to_lev3_stripped  && ((a:Long)=>(a>0))

  val to_unblock_delay=(to_lev0_stripped || to_lev1_stripped || to_lev2_stripped || to_lev3_stripped)  && ((a:Long)=>(a<=0))

  to_lev0_delay += ((a:Long)=>lev0(a-1))
  to_lev1_delay += ((a:Long)=>lev1(a-1))
  to_lev2_delay += ((a:Long)=>lev2(a-1))
  to_lev3_delay += ((a:Long)=>lev3(a-1))

  to_unblock_delay += ((a:Long)=>unblock())
  ready += finished _
  lev0(count)
}


object R_Benchmark4 extends Benchmarker {
  val count=500000
  def main(args:Array[String])={
    (1 to iterations).foreach(x => {
      val x=new FSM4(count)
      cycle(x)
    })
  }
}
