package evalnodsl.bench_opt

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

class FSM1(count:Long) extends FSM_abs(count) {
  private val lev0=new ImperativeAsyncEvent[Long]
//  scala.events.sugarjoin.InEvent.markNullaryEventAsync(lev0)

  val (to_lev0_1,to_lev0_2,ready)=mkDisjunction(
    mkChord(lev0,up),
    mkChord(lev0,down),
    mkChord(block,unblock)
  )
  val to_lev0_stripped=(to_lev0_1 || to_lev0_2) map ((a:(Long,Unit))=>a._1)

  val to_lev0_delay= to_lev0_stripped  && ((a:Long)=>(a>0))

  val to_unblock_delay=(to_lev0_stripped)  && ((a:Long)=>(a<=0))

  to_lev0_delay += ((a:Long)=>lev0(a-1))

  to_unblock_delay += ((a:Long)=>unblock())
  ready += finished _

  lev0(count)
}


object R_Benchmark1 extends Benchmarker {
  val count=500000

  scala.events.AsyncProvider.setProviderType(1)
  def main(args:Array[String])={
    (1 to iterations).foreach(x => {
      val x=new FSM1(count)
      cycle(x)
    })
    Thread.sleep(1000)
    System.exit(0)
  }
}
