package evalnodsl.bench_opt

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}
import scala.compat.Platform

class FSM5s(count:Long) extends FSMs_abs (count) {
  private val lev0=new ImperativeAsyncEvent[Long]
  private val lev1=new ImperativeAsyncEvent[Long]
  private val lev2=new ImperativeAsyncEvent[Long]
  private val lev3=new ImperativeAsyncEvent[Long]
  private val lev4=new ImperativeAsyncEvent[Long]


  val (          to_lev1_1,to_lev2_1,to_lev3_1,to_lev4_1,
       to_lev0_1,to_lev1_2,to_lev2_2,to_lev3_2, 
       ready)=mkDisjunction(
    mkChord(lev0,up),
    mkChord(lev1,up),
    mkChord(lev2,up),
    mkChord(lev3,up),
    mkChord(lev1,down),
    mkChord(lev2,down),
    mkChord(lev3,down),
    mkChord(lev4,down),
    mkChord(block,unblock)
  )
  val to_lev0_stripped=to_lev0_1 map firstLong
  val to_lev1_stripped=(to_lev1_1 || to_lev1_2) map firstLong
  val to_lev2_stripped=(to_lev2_1 || to_lev2_2) map firstLong
  val to_lev3_stripped=(to_lev3_1 || to_lev3_2) map firstLong
  val to_lev4_stripped=to_lev4_1 map firstLong

  val to_unblock_delay=(to_lev0_stripped || 
			to_lev1_stripped || 
			to_lev2_stripped || 
			to_lev3_stripped || 
			to_lev4_stripped)  && completed

  to_lev0_stripped += ((a:Long)=>lev0(a+1))
  to_lev1_stripped += ((a:Long)=>lev1(a+1))
  to_lev2_stripped += ((a:Long)=>lev2(a+1))
  to_lev3_stripped += ((a:Long)=>lev3(a+1))
  to_lev4_stripped += ((a:Long)=>lev4(a+1))

  to_unblock_delay += ((a:Long)=>unblock())
  ready += finished _
  ready += ((arg:Any)=>to_lev0_1.disable())
  lev0(0)
}


object R_Benchmark5s extends Benchmarkers {
  val count=500000
  def main(args:Array[String])={
    (1 to iterations).foreach(x => {
      val x=new FSM5s(count)
      cycle(x)
    })
  }
}
