package evalnodsl.finiteStateMachine.singlethread


import scala.events._
import scala.events.sugarjoin.{mkChord,mkDisjunction}
//# cloc 66
//# events: 11 (2+6+3) 
//# imper: 2
//# handler : 5  
//# trigger 2

class Elevator {
  lazy val rnd=new scala.util.Random
                    
  lazy val up=new ImperativeAsyncEvent[Unit] 
  lazy val down=new ImperativeAsyncEvent[Unit] 
  
  lazy val (b1,b2,m1,t1,t2,m2)=mkDisjunction(
      mkChord(reachBottom.afterAsync,down),
      mkChord(reachMiddle.afterAsync,down),
      mkChord(reachTop.afterAsync   ,down),
      mkChord(reachTop.afterAsync   ,up),
      mkChord(reachMiddle.afterAsync ,up),
      mkChord(reachBottom.afterAsync ,up)
      )	
  lazy val b=b1||b2
  lazy val m=m1||m2
  lazy val t=t1||t2
  up+=moveUp _
  down+=moveDown _
  def moveUp(arg:Any):Unit={
	  println(" moving up    <")
  }
  def moveDown(arg:Any):Unit={
	  println(" moving down  >")
  }
  lazy val reachTop=Observable(_reachTop _)
  def _reachTop(arg:Any):Unit={
    println("Top      [+    ]")
  }
  lazy val reachMiddle=Observable(_reachMiddle _)
  def _reachMiddle(arg:Any):Unit={
    println("Middle   [  +  ]")
  }
  lazy val reachBottom=Observable(_reachBottom _)
  def _reachBottom(arg:Any):Unit={
    println("Bottom   [    +]")
  }

  b+=((Unit)=>reachBottom()) // work around for observables
  m+=((Unit)=>reachMiddle())
  t+=((Unit)=>reachTop())
  reachBottom()  
}


// imp 2
class ButtonPusher(val el: Elevator) {
  val rnd = new scala.util.Random
  var halting = false
  def now = scala.compat.Platform.currentTime
  val begin = now
  def run(sec: Int) = {
    val end = now + sec * 1000
    while (now < end) {
      if (rnd.nextBoolean)
        el.up()
      else
        el.down()
      Thread.sleep(600 + 30 * rnd.nextInt(20))
    }
  }
}

object R_FSM_st {
  val elevator=new Elevator
  val buttonPusher=new ButtonPusher(elevator)
  def main(arg:Array[String])={
    buttonPusher.run(40)
  }
}
