package evalnodsl.hoare_conditional

import scala.events._
import scala.events.sugarjoin.{mkChord,mkDisjunction}

//# cloc 71
//# events 8
//# imper 2
//# handlers 5
//# trigger 2

class CriticalRegionContainer {
  val rnd=new scala.util.Random
  val syncMethod=Observable(_syncMethod)
  def _syncMethod(arg:String):Unit={
    println("begin "+Thread.currentThread().getName()+"  "+arg)
    Thread.sleep(100+rnd.nextInt(30)*20)
    println("end   "+Thread.currentThread().getName()+"  "+arg)
  }
}


class  Requestor(name:String,action:()=>Unit) extends Thread(name) {
  val rnd=new scala.util.Random
  var halting=false
  override def start={
    halting=false
    super.start
  }
  override def run={
    while (!halting) {
      action()
      Thread.sleep(100+10*rnd.nextInt(50))
    }
  }
  def halt={halting=true}
}

class Global {
  var value=false
  val setValue=Observable(_setValue)
  def _setValue(v:Boolean):Unit=synchronized{value=v}
  def getValue()={value}
}

class Conditional_je(val crc:CriticalRegionContainer,val global:Global) {
	def display(name:String)(arg:Any)={
	  println(" "+name+ "  "+arg+"  thread["+Thread.currentThread().getName+"]  "+global.getValue)}
	lazy val initialUnblock=new ImperativeAsyncEvent[Unit]
	lazy val blockAgain=new ImperativeEvent[Unit]
	lazy val invertedFilter=(arg:Any)=>{!(global.getValue())}
	
	
	lazy val block=crc.syncMethod.before || blockAgain
	lazy val release=crc.syncMethod.afterAsync ||  initialUnblock || global.setValue.afterAsync
	
	lazy val (maybeStart1)=mkDisjunction(
	    mkChord(block,release))
	//maybeStart1.markSync(block)
	maybeStart1 += ((arg:Any)=> (if (!global.getValue) blockAgain()))
	
	block+= display("block") _
	release += display("release") _
	maybeStart1 += display("maybeStart") _
	global.setValue.after += display("setvalue.after") _
	
	initialUnblock()
}

object R_HoareConditional {
  val crc=new CriticalRegionContainer
  val global=new Global
  val requestors=List("alpha","beta","gamma").map(x=>new Requestor(x,()=>crc.syncMethod(x+"_ ")))
  val worldChangers=List("earth").map(x=>new Requestor(x,toggleGlobal _))

  def toggleGlobal():Unit={
    val newState=true ^ global.getValue
    global.setValue(newState)
    println("global "+newState)
  	Thread.sleep(2000) 
  }
  
  def main(args:Array[String])={
    val conditional=new Conditional_je(crc,global)
    requestors.foreach(r=>r.start)
    worldChangers.foreach(r=>r.start)
   
    Thread.sleep(100*1000)
    worldChangers.foreach(r=>r.halt)
    requestors.foreach(r=>r.halt)
    println("ending")
  }
}
