package scala.events.dsl

import scala.collection.mutable.ListBuffer
import scala.collection.immutable.HashMap
import scala.collection.immutable.{Set,ListSet}
import scala.events.{Event,ImperativeAsyncEvent,AbstractImperativeEvent,VarList}
import scala.events.disjunctjoin.{Chord,Disjunction}



trait FSM_Jm[S] extends FSM_DSLm[S] {
  class Structs {
    var _stateEvent:HashMap[S,ImperativeAsyncEvent[Unit]]=new HashMap()
    var _actionEventNames=new HashMap[Event[Unit],Int]
    var _state_event_names:HashMap[S,String]=new HashMap[S,String]()
    var _state_event_decls:List[String]=List()
    var _join_events_list:List[String]=List()
    var _disjunction:Disjunction=null
    var _incomingEvents:HashMap[S,VarList[Chord]]=null
    var _joinStrings:List[String]=null
    var _chordEvents:List[S]=List()
    def has_disjunction=(_disjunction!=null)
    def has_stateEvent=(!(_stateEvent.isEmpty))
    def has_joinStrings=(_joinStrings!=null)
    def has_chordEvents=(!(_chordEvents.isEmpty))
    def has_join_events_list=(!(_join_events_list.isEmpty))
    def has_incomingEvents=(!(_incomingEvents.isEmpty))
    def has_state_event_decls=(!(_state_event_decls.isEmpty))
    def has_state_event_names=(!(_state_event_names.isEmpty))
  }
  private var hlp=new Structs

  override def unFreeze()={
    if (hlp.has_disjunction) disjunction.disable()
    hlp=new Structs
    super.unFreeze()  
  }
  //var _actionEventNames=new HashMap[Event[Unit],Int]
  def actionEventName(action:Event[Unit])="action_"+(if (hlp._actionEventNames.contains(action)) {
    hlp._actionEventNames(action)
  } else {
    val nId=hlp._actionEventNames.size
    hlp._actionEventNames =  hlp._actionEventNames + ((action, nId))
    nId
  })

  // stateEvent is a hashmap by applying the state it returns an event
  // var _stateEvent:HashMap[S,ImperativeAsyncEvent[Unit]]=new HashMap()
  def stateEvent={
    if (!(hlp.has_stateEvent)) {
      hlp._stateEvent=states.foldLeft(new HashMap[S,ImperativeAsyncEvent[Unit]])((z,x)=>z+((x,new ImperativeAsyncEvent[Unit])))
    }
    hlp._stateEvent
  }

  // for an optional code generator
  // var _state_event_names:HashMap[S,String]=new HashMap[S,String]()
  def state_event_names={
    if (!(hlp.has_state_event_names)) {
      hlp._state_event_names=states.foldLeft(new HashMap[S,String])((z,x)=>z+{ 
	val state_name_raw=x.toString.substring(1+x.toString.lastIndexOf('.'))
	val state_name=if (state_name_raw.contains("$"))
			 state_name_raw.substring(0,state_name_raw.indexOf("$"))
		       else
			 state_name_raw
	(x,"state_"+state_name)
      })
    }
    hlp._state_event_names
  }
  def  state_event_decls={
    if (!(hlp.has_state_event_decls))
      hlp._state_event_decls=states.map(s=>"lazy val "+state_event_names(s)+" = new scala.events.ImperativeAsyncEvent[Unit]").toList
    hlp._state_event_decls
  }
  def join_events_list={
    if (!(hlp.has_join_events_list)) {
      var hm=new scala.collection.mutable.HashMap[S,Int]
      hlp._join_events_list= chordEvents.map(k=>{
	if (!(hm.contains(k))) {
	  hm(k)=0
	} else {
	  hm(k)=hm(k)+1
	}
	"to_"+state_event_names(k)+"_"+hm(k)
      })
    }
    hlp._join_events_list
  }
  def disjunction={
    if (!hlp.has_disjunction) createDisjunction
    hlp._disjunction
  }

  def incomingEvents={
    if (!(hlp.has_incomingEvents)) createDisjunction
    hlp._incomingEvents
  }

  def joinStrings={
    if (!(hlp.has_joinStrings))
      createDisjunction
    hlp._joinStrings
  }
  def chordEvents={
    if (!(hlp.has_chordEvents))
      createDisjunction
    hlp._chordEvents
  }
  def createDisjunction():Unit={
    if (hlp.has_disjunction)
      return
    val chords=transitions.toList.map(t=>{(t,
					   new Chord(List(stateEvent(t.from),t.action)),
					   "mkChord("+state_event_names(t.from)+", "+actionEventName(t.action)+")",
					   t.to
					 )})
    val disjunction=new Disjunction(chords.toList.map(t=>t._2))
    val chordEvents=chords.map(ch=>ch._4)
    val intermediateEvents=chordEvents.foldLeft(new HashMap[S,VarList[Chord]]())((z,x)=>z+((x,{
      val varlist=new VarList[Chord]
      chords.filter((ch:(Transition,Chord,String,S))=>(x==(ch._1.to))).foreach(ch=>{
	varlist += (ch._2)
        // attach a handler to trigger an optional events and functions
	ch._2+=((arg:List[_])=>{ch._1.onMove.foreach(f=>{ f.apply() })})
      })
      varlist
    })))
    val intermediate_keys=intermediateEvents.map(kv=>kv._1)
    intermediate_keys.foreach(triggerEvent=>{
      val intermediate=intermediateEvents(triggerEvent).any(t=>t.dropParam)
      val targetEvent=stateEvent(triggerEvent)
      intermediate += ((arg:Unit)=>{targetEvent.apply()})
    })
    hlp._disjunction=disjunction
    hlp._incomingEvents=intermediateEvents
    hlp._joinStrings=chords.map(ch=>ch._3).toList
    hlp._chordEvents=chordEvents
  }
  
  // after setting the initial event
  def initialState(initialState:S)={
    if (frozen) 
      throw new  java.lang.IllegalStateException("states already frozen")
    createDisjunction()
    stateEvent(initialState)()
  }
  def joinStringList(lst:List[String],sep:String)=if (lst.isEmpty)  
						    "" else  lst.tail.foldLeft(lst.head)((z,x)=>{z+sep+x})
  
  def showStat={
    transitions.foreach(t=>println("transition :"+t))
    states.foreach(s=>println("// state :"+s))
    stateEvent.foreach(s=>println("stateEvent "+s))
    println(disjunction)
    incomingEvents.keys.foreach(l=>{
      println("Incoming for "+l+"  "+incomingEvents(l))
    })
    println("// state events")
    println(joinStringList(state_event_decls,"\n"))
    println("// disjunction")
    println("lazy val (\n  "+joinStringList(join_events_list,"  ,\n  ")
	    +" )= mkDisjunction(\n    "
	    +joinStringList(joinStrings," , \n    ")
	    +" )")

    println("// combining events")
    incomingEvents.keys.toList.map(k=>{
      "  lazy val to_"+state_event_names(k)+" = ("+joinStringList(
	(1 to incomingEvents(k).size).map(it=>"to_"+state_event_names(k)+"_"+it).toList,"\n    || ")+"  )"}).foreach(l=>println(l))

    println("// trigger new State")
    incomingEvents.keys.toList.map(k=>{
      " to_"+state_event_names(k)+" += ((arg:(Unit,Unit))=>{ "+state_event_names(k)+"() })"}).toList.foreach(l=>println(l))
  }

  def deploy()=disjunction.enable()
  def undeploy()=disjunction.disable()
}



