package scala.events.dsl

import scala.events.{EventNode,AbstractImperativeEvent,EventNodeMap}
import scala.reflect.runtime.universe._
import scala.language.implicitConversions

// When events are combined in a Join pattern often we only need a part of them
// However, this involves a map(arg:(...)=>arg._2) which is more verbose then we
// like.
// The alternative here is
//  evt a[(Int,String)]
//  evt b=a._1  // evt[Int]


trait ProjectionDSL {
  implicit def ev2splitable[T1,T2](
    ev:EventNode[(T1,T2          )]
  )=new Splitable2(ev)
  
  implicit def ev3splitable[T1,T2,T3](
    ev:EventNode[(T1,T2,T3)      ]
  )=new Splitable3(ev)

  implicit def ev4splitable[T1,T2,T3,T4](
    ev:EventNode[(T1,T2,T3,T4  )]
  )=new Splitable4(ev)

  implicit def ev5splitable[T1,T2,T3,T4,T5](
	ev:EventNode[(T1,T2,T3,T4,T5)]
  )=new Splitable5(ev)

  implicit def ev6splitable[T1,T2,T3,T4,T5,T6](
	ev:EventNode[(T1,T2,T3,T4,T5,T6)]
  )=new Splitable6(ev)


  class Splitable2[T1,T2](val received_event:EventNode[(T1,T2)]) {
    type EV_TYPE=(T1,T2)
    def _1=new EventNodeMap[EV_TYPE,
			    T1](received_event,
				((arg:EV_TYPE)=>arg._1) )
    def _2=new EventNodeMap[EV_TYPE,
			    T2](received_event,
				((arg:EV_TYPE)=>arg._2) )
  }

  class Splitable3[T1,T2,T3](val received_event:EventNode[(T1,T2,T3)]) {
    type EV_TYPE=(T1,T2,T3)
    def _1=new EventNodeMap[EV_TYPE,
			    T1](received_event,
				((arg:EV_TYPE)=>arg._1) )
    def _2=new EventNodeMap[EV_TYPE,
			    T2](received_event,
				((arg:EV_TYPE)=>arg._2) )
    def _3=new EventNodeMap[EV_TYPE,
			    T3](received_event,
				((arg:EV_TYPE)=>arg._3) )
  }

  class Splitable4[T1,T2,T3,T4](val received_event:EventNode[(T1,T2,T3,T4)]) {
    type EV_TYPE=(T1,T2,T3,T4)
    def _1=new EventNodeMap[EV_TYPE,
			    T1](received_event,
				((arg:EV_TYPE)=>arg._1) )
    def _2=new EventNodeMap[EV_TYPE,
			    T2](received_event,
				((arg:EV_TYPE)=>arg._2) )
    def _3=new EventNodeMap[EV_TYPE,
			    T3](received_event,
				((arg:EV_TYPE)=>arg._3) )
    def _4=new EventNodeMap[EV_TYPE,
			    T4](received_event,
				((arg:EV_TYPE)=>arg._4) )
  }
  class Splitable5[T1,T2,T3,T4,T5](val received_event:EventNode[(T1,T2,T3,T4,T5)]) {
    type EV_TYPE=(T1,T2,T3,T4,T5)
    def _1=new EventNodeMap[EV_TYPE,
			    T1](received_event,
				((arg:EV_TYPE)=>arg._1) )
    def _2=new EventNodeMap[EV_TYPE,
			    T2](received_event,
				((arg:EV_TYPE)=>arg._2) )
    def _3=new EventNodeMap[EV_TYPE,
			    T3](received_event,
				((arg:EV_TYPE)=>arg._3) )
    def _4=new EventNodeMap[EV_TYPE,
			    T4](received_event,
				((arg:EV_TYPE)=>arg._4) )
    def _5=new EventNodeMap[EV_TYPE,
			    T5](received_event,
				((arg:EV_TYPE)=>arg._5) )
  }
  class Splitable6[T1,T2,T3,T4,T5,T6](val received_event:EventNode[(T1,T2,T3,T4,T5,T6)]) {
    type EV_TYPE=(T1,T2,T3,T4,T5,T6)
    def _1=new EventNodeMap[EV_TYPE,
			    T1](received_event,
				((arg:EV_TYPE)=>arg._1) )
    def _2=new EventNodeMap[EV_TYPE,
			    T2](received_event,
				((arg:EV_TYPE)=>arg._2) )
    def _3=new EventNodeMap[EV_TYPE,
			    T3](received_event,
				((arg:EV_TYPE)=>arg._3) )
    def _4=new EventNodeMap[EV_TYPE,
			    T4](received_event,
				((arg:EV_TYPE)=>arg._4) )
    def _5=new EventNodeMap[EV_TYPE,
			    T5](received_event,
				((arg:EV_TYPE)=>arg._5) )
    def _6=new EventNodeMap[EV_TYPE,
			    T6](received_event,
				((arg:EV_TYPE)=>arg._6) )
  }

}
