package scala.events.dsl

import scala.events.{EventNode,AbstractImperativeEvent,EventNodeMap}
import scala.reflect.runtime.universe._
import scala.language.implicitConversions

// When events are combined in a Join pattern often we only need a part of them
// However, this involves a map(arg:(...)=>arg._2) which is more verbose then we
// like.
// The alternative here is
//  evt a[(Int,String)]
//  evt b=a._1  // evt[Int]


trait ProjectDSL {
  implicit def ev2splitable[S,T](ev:EventNode[(S,T)])=new Splitable2(ev)
  implicit def ev3splitable[S,T,U](ev:EventNode[(S,T,U)])=new Splitable3(ev)
  implicit def ev4splitable[S,T,U,V](ev:EventNode[(S,T,U,V)])=new Splitable4(ev)

  class Splitable2[S,T](val received_event:EventNode[(S,T)]) {
    def _1={
      new EventNodeMap[(S,T),S](received_event,((arg:(S,T))=>arg._1))
    }
    def _2={
      new EventNodeMap[(S,T),T](received_event,((arg:(S,T))=>arg._2))
    }
  }
  class Splitable3[S,T,U](val received_event:EventNode[(S,T,U)]) {
    def _1={
      new EventNodeMap[(S,T,U),S](received_event,((arg:(S,T,U))=>arg._1))
    }
    def _2={
      new EventNodeMap[(S,T,U),T](received_event,((arg:(S,T,U))=>arg._2))
    }
    def _3={
      new EventNodeMap[(S,T,U),U](received_event,((arg:(S,T,U))=>arg._3))
    }
  }
  class Splitable4[S,T,U,V](val received_event:EventNode[(S,T,U,V)]) {
    def _1={
      new EventNodeMap[(S,T,U,V),S](received_event,((arg:(S,T,U,V))=>arg._1))
    }
    def _2={
      new EventNodeMap[(S,T,U,V),T](received_event,((arg:(S,T,U,V))=>arg._2))
    }
    def _3={
      new EventNodeMap[(S,T,U,V),U](received_event,((arg:(S,T,U,V))=>arg._3))
    }
    def _4={
      new EventNodeMap[(S,T,U,V),V](received_event,((arg:(S,T,U,V))=>arg._4))
    }
  }

}
