package scala.events.util

import scala.events.{ImperativeAsyncEvent,EventNode,Observable,VarList}
import scala.events.sugarjoin.{mkChord,mkDisjunction}

object RWLock {
  def apply(shared:List[Observable[_,_]],
	     exclusive:List[Observable[_,_]] )=new RWLock(shared,exclusive)
}

class RWLock(shared:List[Observable[_,_]],
	     exclusive:List[Observable[_,_]] ) {
  def display(prefix:String)(arg:Any)=println(prefix+" "+arg)
  val sharedMths=VarList(shared)
  val exclusiveMths=VarList(exclusive)
  val beginShared=sharedMths.any(obs=>obs.before.dropParam)
  val endShared=sharedMths.any(obs=>obs.after.dropParam)
  val beginExclusive=exclusiveMths.any(obs=>obs.before.dropParam)
  val endExclusive=exclusiveMths.any(obs=>obs.after.dropParam)

  private val idle=new ImperativeAsyncEvent[Unit]
  private val s=new ImperativeAsyncEvent[Int]
  private val lock=new ImperativeAsyncEvent[Unit]
  // lock only enforces consistency (could be removed)
  val (s0,sup,sdown,toLock,toIdle)=
    mkDisjunction(
      mkChord(beginShared,idle),
      mkChord(beginShared,s),
      mkChord(endShared,s),
      mkChord(beginExclusive,idle),
      mkChord(endExclusive,lock)
  )
  s0 += ((arg:(Unit,Unit))=>s(0))
  sup += ((arg:(Unit,Int))=>s(arg._2+1))
  sdown += ((arg:(Unit,Int))=>if (arg._2>0) s(arg._2-1) else idle())
  toLock += ((arg:(Unit,Unit))=>lock())
  toIdle += ((arg:(Unit,Unit))=>idle())
//  s0    += display("s0") _
//  sup   += display("sup") _
//  sdown += display("sdown") _
//  toLock += display("toLock") _
//  toIdle += display("toIdle") _
  idle() // initialize
}
