package test.animal_sim
import scala.events.{ImperativeEvent,ImperativeAsyncEvent,Observable}
import scala.collection.immutable.List

class Animal(b:Board) extends BoardElement {
  val rnd=new scala.util.Random
  setBoard(b)

  val moveAround=new ImperativeAsyncEvent[Unit]
  moveAround += atMoveAround _

  def atMoveAround(arg:Unit):Unit={
    val np=around(3)
    println(posString+"  np="+np)
    getBoard.requestMove((getX,getY),np)
  }

  def around(r:Int):(Int,Int)={
    val s1=if (rnd.nextBoolean) 1 else (0-1)
    val s2=if (rnd.nextBoolean) 1 else (0-1)
    val x=rnd.nextInt(r)*s1
    val y=s2*((math.sqrt(r*r-x*x)*rnd.nextInt(10))/10).toInt
    val nx=getX+x
    val ny=getY+y
    if (getBoard.free(nx,ny))
      (nx,ny)
    else
      around(r)
  }

 
}


object R_boardTest {
  val rnd=new scala.util.Random
  val brd=new Board(20,20)
  def freePos:(Int,Int)={
    val x=rnd.nextInt(brd.col)
    val y=rnd.nextInt(brd.row)
    if (brd.free(x,y))
      (x,y)
    else
      freePos
  }
  def populate(cont:Int)={
    var lst=(0 to cont).toList
    val animals=lst.map(x => new Animal(brd))
    animals.foreach(an => {
      val p=freePos
      println("p="+p)
      an.moveTo(p)
    })
    animals
  }
  def main(arg:Array[String]) {
    val animals=populate(5)
    println(brd.content)
    println(brd.dump(" "))
    (1 to 100).foreach(i=>{
      animals.foreach(an => an.moveAround())
      Thread.sleep(1000)
      println(brd.dump(" "))
    })
  }
}
