package test.concurrent
import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkDisjunction,mkChord}


class C_calc {
  def display(name:String)(arg:Long)={println("display "+name+" : "+arg)}
  val r=new ImperativeAsyncEvent[Long]
  val result_r=new ImperativeAsyncEvent[Long]

  val k=new ImperativeAsyncEvent[Long]
  val result_k=new ImperativeAsyncEvent[Long]

  val rk_joins=mkDisjunction(mkChord(r,k))

  val r_k=rk_joins map ((arg:(Long,Long))=>arg._1-arg._2)
  val result_r_k=new ImperativeAsyncEvent[Long]
  
  r += handle_r _
  k += handle_k _
  r_k += handle_r_k _

  r += display("R") _
  k += display("K") _
  r_k += display("R-K") _

  def handle_r(arg:Long):Unit={
    result_r(slow_fac(arg))
  }

  def handle_k(arg:Long):Unit={
    result_k(slow_fac(arg))
  }

  def handle_r_k(arg:Long):Unit={
    result_r_k(slow_fac(arg))
  }

  def slow_fac(arg:Long)={
    var iter:Long=0
    var res:Long=1
    while (iter<arg) {
      iter+=1
      res*=iter
      Thread.sleep(3000)
    }
    println("fac("+arg+")="+res)
    res
  }
  
  val combine=mkDisjunction(mkChord(result_r,result_k,result_r_k))

  combine += combine_handler _

  def combine_handler(arg:(Long,Long,Long)):Unit={
    val res=(arg._1.toDouble)/(arg._2*arg._3)
    println("result :"+res)
  }
 
}

object R_Concurrent {
  val c=new  C_calc
  def main(arg:Array[String])={
    c.r(5)
    c.k(3)
  }
}
