package test.dsl.bench

import scala.actors.Actor
import scala.actors.Actor._


class FSM_Con_Actor(iter:Int) extends Bench(iter,"StatePat_Con") {
  outer =>
  case class Left() {}
  case class Right() {}
  case class Halt() {}

  object core extends Actor {

    trait State {
      def left
      def right
    }
    object top extends State {
      def left={setState(middle)}
      def right={setState(bottom)}
    }
    object middle extends State {
      def left={setState(bottom)}
      def right={setState(top)}
    }
    object bottom extends State {
      def left={setState(top)}
      def right={setState(middle)}
    }

    var running:Boolean=true
    var currentState:State=bottom

    def setState(s:State)=if (running) {
      currentState=s
      outer.trigger()
    }

    def act()={
      running=true
      loopWhile(running) {
	react {
          case Left()  => currentState.left
          case Right() => currentState.right
	  case Halt() => running=false
	}
      }
    }
  }
  
 val handle_left=   ((arg:Unit)=>core ! Left())
 val handle_right=  ((arg:Unit)=>core ! Right())



  def deploy()={
    es.l += handle_left
    es.r += handle_right

    core.start
  }
  def undeploy()={
    es.l -= handle_left
    es.r -= handle_right
    
    core.running=false
    core ! Halt()
  }
  deploy()
}
