package test.dsl.bench

class FakeRandom {
      var currentval:Int=0
      var prev:Int=1
      def next()=synchronized {
      	  val nextval=currentval+prev
	  prev=currentval
	  currentval=nextval
	  currentval
      } 
      def nextInt(upper:Int)=(next() % upper)
}

class EventSource {
  val rnd=new FakeRandom
  val l=new scala.events.ImperativeAsyncEvent[Unit]
  val r=new scala.events.ImperativeAsyncEvent[Unit]
  val u=new scala.events.ImperativeAsyncEvent[Unit]
  val d=new scala.events.ImperativeAsyncEvent[Unit]
  def trigger()= rnd.nextInt(4) match {
    case 0 => {l()}
    case 1 => {r()}
    case 2 => {u()}
    case 3 => {d()}
    case _ =>{}
  }
  def haltAsync()=List(l,r,u,d).foreach(e => e.haltAsync())
}

class Timer(val name:String) {
  private var beginTime:Long=0
  private var endTime:Long=0
  def start={
    beginTime=scala.compat.Platform.currentTime
  } 
  def stop={
    endTime=scala.compat.Platform.currentTime
    if (beginTime==0) throw new IllegalStateException("stop needs a start for Timer("+name+")")
    val duration=endTime-beginTime
    println("Duration "+name+" :"+duration+"ms (="+(duration+500)/1000+"s)")
    duration
  } 
}
