package test.dsl.fsme

import scala.events.dsl.{FSM_J,FSM_N,FSM_E}

import scala.events.{Event,ImperativeAsyncEvent,AbstractImperativeEvent,VarList}


sealed trait State
object top extends State
object middle extends State
object bottom extends State


object R_Using_FSME_DSL extends FSM_E[State] {
  val rnd=new scala.util.Random
  def display(prefix:String)(arg:Any)=println(prefix+" "+arg)
  def main(args:Array[String])={
    val up=new scala.events.ImperativeAsyncEvent[Unit]
    val up2=new scala.events.ImperativeAsyncEvent[Unit]
    val down=new scala.events.ImperativeAsyncEvent[Unit]
    val down2=new scala.events.ImperativeAsyncEvent[Unit]
    val extra1=new scala.events.ImperativeEvent[Unit]
    val extra2=new scala.events.ImperativeEvent[Unit]

    top ->  middle  on down apply(()=>{println(" @ middle")})
    middle -> bottom on down apply(()=>{println(" @ bottom")})
    bottom -> bottom on (down,down2) triggers(extra1,extra2) apply(()=>{println(" @ bottom")})
    bottom -> middle  on up apply(()=>{println(" @ middle")})
    middle -> top  on up apply(()=>{println(" @ top")})
    top -> top on up apply(()=>{println(" @ top")})
    top -> bottom on up2 apply(()=>{println(" @ bottom")})
    initialState(bottom)


  //  showStat
    println("Waiting to start sending random events")
    Thread.sleep(1000)

    extra1 += display("bottomloop1") _
    extra2 += display("bottomloop2") _
   // stateEvent(top) += display("top") _

    while (true) {
      rnd.nextInt(5) match {
	case 0 => {
	  println("* up")
	  up() }
	case 1 => {
	  println("* up2")
	  up() }

	case 2 => {
	  println("* down")
	  down()
	}
	case 3 => {
	  println("* down2")
	  down2()
	}
	case _ => {}
      }
      Thread.sleep(1000)
    }
  }

}
