package test.dsl.rwlock

import scala.events.util.RWLock
import scala.events.Observable

class Sample(name:String) extends Thread {
  val rnd=new scala.util.Random
  def waitABit=Thread.sleep(20+10*rnd.nextInt(48))
  override def run={
    waitABit
    mth()
  }
  val mth=Observable(_mth)
  def _mth(arg:Unit)={
    println("> begin "+name+" >")
    waitABit
    println("< end   "+name+" <")
  }
}

object R_lockTest {
  val sharing=List("nice1","nice2","nice3").map(n=>new Sample(n))
  val exclusive=List("mean1", "mean2", "mean3").map(n=>new Sample(n+" .  .  ."))
  def main(arg:Array[String])={
    val lock=new RWLock(sharing.map(s=>s.mth),exclusive.map(s=>s.mth))
    val l=sharing++exclusive
    l.foreach(s=>s.start())
    Thread.sleep(500)
  }
}
