package test.dsl.rwlock1

import scala.events.util.RWLock
import scala.events.Observable

class SharedMemory {
  var a:Int=0
  var b:Int=0
  var c:Int=0 
  def setA(t:Int)={a=t}
  def setB(t:Int)={b=t}
  def setC(t:Int)={c=t}
  def set(t:Int,v:Int)=t match {
    case 0 => {
      setA(v)
      " "+v+" => A"
    }
    case 1 => {
      setB(v)
      " "+v+" => B"
    }
    case 2 => {
      setC(v)
      " "+v+" => C"
    }
    case _ => throw new IllegalArgumentException("unknow var")
  }  
  
  def getSum(t:Int)=t match {
    case 0 => {
      ("[]","",0)
    }
    case 1 => {
      ("[C]", ""+c, c)
    }
    case 2 => {
      ("[B]",""+b,b)
    }
    case 3 => { 
      ("[B+C]",""+b+"+"+c,b+c)
    }
    case 4 => {
      ("[A]",""+a,a)
    }
    case 5 => {
      ("[A+C]",""+a+"+"+c,a+c)
    }
    case 6 => {
     ("[A+B]", ""+a+"+"+b,a+b)
    }
    case 7 => {
      ("[A+B+C]",""+a+"+"+b+"+"+c,a+b+c)
    }
    case _  => throw new IllegalArgumentException("unknow var")
  }
}

abstract class AbsWorker(val name:String,cnt:Int) extends Thread {
  val rnd=new scala.util.Random
  var count=cnt
  def waitABit()=Thread.sleep(rnd.nextInt(100))
  override def run={
    waitABit()
    while (count>0) {
      Thread.sleep(200)
      mth()
      count -=1
    }
  }
  val mth=Observable(_mth)
  def _mth(arg:Unit)
  def ready=(count==0)
}

class Reader(name:String,resource:SharedMemory,cnt:Int) extends AbsWorker(name,cnt) {
   def _mth(arg:Unit)={
     waitABit()
     val t=rnd.nextInt(8)
     val res=resource.getSum(t)
     println("reader "+name+" "+res._1+" => "+res._2+" = "+res._3)
   }
}

class Writer(name:String,resource:SharedMemory,cnt:Int) extends AbsWorker(name,cnt) {
   def _mth(arg:Unit)={
     waitABit()
     val t=rnd.nextInt(3)
     val v=rnd.nextInt(10)
     println("writer "+name+" "+resource.set(t,v))
   }
}



object R_lockTest {
  val iterations=10
  val rnd=new scala.util.Random
  val sharedMemory=new SharedMemory
  val readers=List(
    "r1",
    "r2").map(readerName=>new Reader(readerName,sharedMemory,iterations))
  val writers=List(
    "w1", 
    "w2", 
    "w3", 
    "w4").map(writeName=>new Writer(writeName,sharedMemory,iterations))
  def main(arg:Array[String])={
    RWLock(shared=readers.map(s=>s.mth),exclusive=writers.map(s=>s.mth))
    val l=readers++writers
    l.foreach(s=>s.start())
    while (l.exists(s=>(!(s.ready))))
      Thread.sleep(500)
    System.exit(0)
  }
}
