package test.t1

// ${SCALA_HOME}/bin/scala  -Dactors.corePoolSize=10 -Dactors.enableForkJoin=false test.t1.AsyncTest
//
// the "recycling" by the threadpool could show  "false" results in the test
//
// test to show that the handler display is executed by different threads

import scala.events.{ImperativeEvent,ImperativeAsyncEvent}
import scala.events.sugarjoin.{mkChord,mkDisjunction}

import scala.collection.mutable.HashMap

class AsyncTest {
  val used_thread=new HashMap[String,String]()
  def display(name:String)(arg:Any):Unit={
    println(name+" "+arg+" "+Thread.currentThread)
    used_thread(name)=Thread.currentThread.toString
  }

  val a=new ImperativeAsyncEvent[Char]
  val b=new ImperativeAsyncEvent[Char]
 
  val d=mkDisjunction(mkChord(a,b))

  a += display("A") _
  b += display("B") _
  d += display("D") _

  def differentThreads:Boolean=
    used_thread("A") != used_thread("B") && 
    used_thread("A") != used_thread("D") && 
    used_thread("D") != used_thread("B") 

  def threadAeqThreadB=used_thread("A")==used_thread("B")
  def threadAeqThreadD=used_thread("A")==used_thread("D")
  def threadBeqThreadD=used_thread("B")==used_thread("D")
}

object R_AsyncTest {
  val asynctest=new AsyncTest
  def main(arg:Array[String])={
    println("all display-handlers should be executed by different threads")
    asynctest.a('1')
    asynctest.b('2')
    Thread.sleep(1000)
    println("All handlers executed by different threads :"+asynctest.differentThreads)
    Thread.sleep(1000)
    println("lets see which thread executes the handler this time (simulate synchronous b)")
    asynctest.a('a')
    asynctest.b.triggerEvent('b',true)
    println("the thread of B handles also D "+ asynctest.threadBeqThreadD)
    println("thead of B is different from the thread of A" + (!asynctest.threadAeqThreadB))
    
  }
}
